// Form to pass to the rewrite
var moreReq;
var myForm;

// Initialize
$(function() {
    $(".current").hide()
    $('#more-btn').hide()
    $('#answer').hide()
    myForm = document.forms["myform"]
    myForm.addEventListener('submit', function (e) {
        e.preventDefault()
        if(myForm.strat.value == "annot"){
            annotation()
        } else {
            rewrite()
        }
    })

    $("#more-btn").on('click', function (e) {
        rewriteMore()
    })

    applyEventListeners()
});

function applyEventListeners() {
    $('.redex').on('mouseover mouseout', function(e) {
        e.stopPropagation()
        $(this).toggleClass("hovered")
    });
}

function postReq(path, data, succ) {
    $.ajax({
        url: path,
        method: "post",
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        data: JSON.stringify(data)
    })
    .done(succ)
    .fail(function (a,b,c) {
        alert("Request failed: response might be to large.")
    });
}

function annotation() {
    moreReq = null

    var data = {
        "problem" : myForm.system.value,
        "term"    : myForm.term.value,
    }
    $('.current').hide()

    postReq("/annotation", data, function(res) {
        if(res.tag=="Err") {
            $("#answer-field").html(res.msg)
        } else {
            $("#answer-field").html(mkAnnotationSequence(res.rewriteSeq))
        }
        $('#answer').show()
        updateScroll()
    })
}

function suggestAnnotation() {
    var data = {
        "problem" : myForm.system.value,
        "term" : myForm.term.value
    }
    $('.current').hide()
    $('#more-btn').hide()
    postReq("/annotation/suggest", data, function(res) {
        if(res.tag=="Err") {
            $("#answer-field").html(res.msg)
        } else {
            var string = "Just-in-time annotation:</br>"
            for(var i=0; i<res.annotation.length; i++) {
                string += res.annotation[i]
                string += "</br>"
            }
            $("#answer-field").html(string)
        }
        $('#answer').show()
    })
}

function suggestStrategy() {
    var data = {
        "system" : myForm.system.value
    }
    $('.current').hide()
    $('#more-btn').hide()

    postReq("/strategies/suggest", data, function(result) {
        answer = ""
        if(result.tag == "suggestion") {
            var strategies = result.strategies
            answer = "Normalizing Strategies:</br>"
            answer += strategies.join("</br>\t")
        } else if(result.tag == "NoSuggestion") {
            answer = "No Suggested Strategies for the given TRS."
        } else {
            answer = result.msg
        }
        $("#answer-field").html(answer)
        $('#answer').show()
    })
}

// when the submit button is clicked
function rewrite() {
    var data = {
        "system"   : myForm.system.value,
        "term"  : myForm.term.value,
        "strat" : myForm.strat.value
    }

    postReq("/rewrite", data, function(res) {
        if(res.tag=="PErr") {
            $("#answer-field").html(res.msg)
        } else {
            seq = res.rewriteSeq.map(i => i[0])
            $("#answer-field").html(mkSequence(seq,true))
            moreReq = res.nextReq
            if(moreReq) {
                $("#more-btn").show()
            } else {
                $("#more-btn").hide()
            }

            animseq = res.rewriteSeq.map(i => constructTerm([i[0],i[1]]))
            animstate = {
                "active" : false,
                "step" : 0,
                "sequence" : animseq
            }
            $(".current").show()
            previouseState()
        }
        $('#answer').show()
        updateScroll()
    })
}

// when the 'More' Button is pressed
function rewriteMore() {
    if(moreReq) {
        postReq("/rewrite", moreReq, function(res) {
            if(res.tag=="PErr") {
                $("#answer-field").append("</br>")
                $("#answer-field").append(res.msg)
                $("#more-btn").hide()
            } else {
                seq = res.rewriteSeq.map(i => i[0])
                $("#answer-field").append(mkSequence(seq,false))
                moreReq = res.nextReq
                animseq = res.rewriteSeq.map(i => constructTerm([i[0],i[1]]))
                animstate.sequence = animstate.sequence.concat(animseq)
                $(".current").show()
            }
            $('#answer').show()
            updateScroll()
        })
    }
}

function mkAnnotationSequence(res) {
    var answer = "> normalize( "
    for(var i = 0; i< res.length; i++) {
        if(i>0){
            answer += "</br>"
            answer += "-".repeat(res[i].stack.length)
            answer += "> normalize( "
        }
        answer += "<b>" + buildTerm(res[i].term) + "</b>"
        answer += ", ["
        var annotations = res[i].annotation
        if(annotations.length >= 1) {
            annotations[0] = "<b>" + annotations[0] + "</b>"
        }
        answer += res[i].annotation.join()
        answer += "] )"
    }
    return answer
}

function buildTerm(term) {
    var answer = ""
    if(term.tag=="Fun") {
        answer = term.name
    if(term.params.length > 0) {
        answer += "(" + term.params.map(buildTerm).join() + ")"
    }
    } else {
        answer = term.name
    }
    return answer
}

function mkSequence(res,first) {
    var answer = ""
    if(first){
        answer += buildTerm(res[0])
    }
    var l = res.length
    for(var i=1; i<l; i++) {
        answer += " &#8209;>&nbsp;"
        answer += buildTerm(res[i])
    }
    return answer
}

function updateScroll() {
    var element = document.getElementById("answer")
    element.scrollTop = element.scrollHeight
}

function constructTerm(data) {
    var term = data[0]
    var reducts = data[1]

    for(var i = 0; i < reducts.length; i++) {
        position = reducts[i].pos
        subterm = term
        for(var j = 0; j < position.length; j++) {
            subterm = subterm.params[position[j]]
        }
        subterm.redex = {
            "resultTerm" : reducts[i].result,
            "rule" : reducts[i].rule.lhs + " -> " + reducts[i].rule.rhs
        }
    }

    return term
}

function displayCurrentTerm(data) {
    var func = document.createElement("span")
    if (data.tag = "Fun") {
        $(func).addClass("fun")
    }
    if (data.redex) {
        $(func).addClass("redex")
        $(func).on('click', function(e) {
            e.stopPropagation()
            console.log("clicked")
        })
        $(func).on('mouseover mouseout', function(e) {
            e.stopPropagation()
            $(this).toggleClass("hovered")
            displayCurrentInfo(data.redex)
        })
    }

    func.append(data.name)
    if (data.params && data.params.length > 0) {
        func.append("( ")
        func.append(displayCurrentTerm(data.params[0]))
        for (var i = 1; i < data.params.length; i++) {
            func.append(", ", displayCurrentTerm(data.params[i]))
        }
        func.append(" )")
    }
    return func
}
function displayCurrentInfo(data) {
    $(".current-info-rule").html(data.rule)
    $(".current-info-result").html(data.resultTerm)
    $(".current-info-rule").toggle()
    $(".current-info-result").toggle()
}

// Animation
var animstate = {
    "active" : false,
    "step" : 0,
    "sequence" : [],
}

function nextState() {
    animstate.step = Math.min(animstate.sequence.length-1, animstate.step + 1)
    $(".current-term").html(displayCurrentTerm(animstate.sequence[animstate.step]))
}

function previouseState() {
    animstate.step = Math.max(0, animstate.step - 1)
    $(".current-term").html(displayCurrentTerm(animstate.sequence[animstate.step]))
}

function toggleAnim() {
    if(animstate.active){
        animstate.active = false
    } else {
        animstate.active = true
        var id = setInterval(function() {
            if(animstate.active && animstate.step < animstate.sequence.length - 1) {
                $(".redex").addClass("hovered")
                setTimeout(function() {
                    nextState()
                }, 1500)
            } else {
                clearInterval(id)
                animstate.active = false
            }
        }, 2500)
    }
}
